# Running containers in Azure 

1. Login in azure with user@fi365.ort.edu.uy 

```bash 
	docker login azure 
```
2. Create context

```bash 
	docker context create aci generate-normal-traffic 
```
3. Select 'ai-research' as resource group
4. Create storage at azure 'normaltraffic'
5. Create file share at azure for low level
```bash 
	sh create_file_share.sh 'normaltraffic' 'low'
```

6. Run DVWA application

6.1 Without WAF: 
```bash 
docker --context generate-normal-traffic run -d -v normaltraffic/normal:/var/log/apache2/ --name dvwa-normaltraffic -p 80:80 aracloud/docker-dvwa

``` 
6.2 With WAF: 
```bash 
docker --context generate-normal-traffic run -d -v normaltraffic/WAFnormal:/var/log/apache2/ --name dvwa-waf-normaltraffic -p 80:80 mikaelapisani/dvwa-modsecurity

``` 
Login into DVWA application and configure it to create the database

7. Run generator: 

Use the corresponding configuration at env.list to run the generator:   

```bash 
	docker --context generate-normal-traffic run -d --env-file env.list --name generate-dvwa-normal-traffic mikaelapisani/generate-dvwa-normal-traffic
``` 

8. Check logs and running containers
```bash 
	docker --context generate-normal-traffic logs dvwa-normaltraffic
	docker --context generate-normal-traffic ps
```

