#!/usr/local/bin/python

import requests
import random
import string
import re
import time
import os
import math
import tempfile

#max number of users configured in DVWA site 
MAX_USERS=5

def get_random_string(n):
	return ''.join(random.choice(string.ascii_letters) for i in range(n))

def get_random_number(n):
	return random.randint(1,n)

def login(url, username, password):
	payload = {
	    'username': username,
	    'password': password,
	    'Login': 'Login'
	}
	c = requests.Session()
	r = c.get(url + '/login.php')
	token = re.search("user_token'\s*value='(.*?)'", r.text).group(1)
	payload['user_token'] = token
	p = c.post(url + '/login.php', data=payload)
	token = re.search("user_token'\s*value='(.*?)'", r.text).group(1)
	return token, c

def run_get(url, c, cookies, args):
	path = args[0]
	print('run_get ', path)
	r = c.get(url + path, cookies=cookies)
	if args!=[]:
		params = '?'
		for arg in args:
			params += arg
		params +='#'
		r = c.get(url + path + params, cookies=cookies)
	return r.text, r.status_code, c


def run_exec(url, c, cookies, args):
	ip_address = args[0]
	print('run_exec IP:', ip_address)
	r = c.get(url + '/vulnerabilities/exec/', cookies=cookies)
	payload = {
		'ip': ip_address,
		'Submit': 'Submit'
	}
	r = c.post(url + '/vulnerabilities/exec/#', data=payload, cookies=cookies)
	time.sleep(2)
	return r.text, r.status_code, c

def run_brute(url, c, cookies, args):
	username = args[0]
	password = args[1]
	print('run_brute username={}, password={}'.format(username, password))
	r = c.get(url + '/vulnerabilities/brute/', cookies=cookies)
	payload = {
		'username': username,
		'password': password,
		'Login':'Login#'
	}
	r = c.get(url + '/vulnerabilities/brute/', data=payload, cookies=cookies)
	return r.text, r.status_code, c

def change_password(url, c, cookies, username, password):
	r = c.get(url + '/vulnerabilities/csrf/', cookies=cookies)
	payload = {
		'password_new': username,
		'password_conf': password,
		'Change':'Change#'
	}
	r = c.get(url + '/vulnerabilities/csrf/', data=payload, cookies=cookies)
	return r.text, r.status_code, c

def run_change_password(url, c, cookies, args):
	username = args[0]
	password = args[1]
	print('run_change_password username={},password={}'.format(username, password))
	_, _, c = change_password(url, c, cookies, args[0], args[2])
	return change_password(url, c, cookies, args[0], args[1])

def run_file_inclusion(url, c, cookies, args):
	print('run_file_inclusion')
	r = c.get(url + '/vulnerabilities/fi/?page=include.txt', cookies=cookies)
	r = c.get(url + '/vulnerabilities/fi/?page=' + args[0], cookies=cookies)
	return r.text, r.status_code, c

def run_file_upload(url, c, cookies, args):
	print('run_file_upload')
	headers = {
	    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.15; rv:85.0) Gecko/20100101 Firefox/85.0',
	    'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
	    'Accept-Language': 'en-US,en;q=0.5',
	    'Content-Type': 'multipart/form-data; boundary=---------------------------8162145238575224561609067227',
	    'Origin': url,
	    'Connection': 'keep-alive',
	    'Referer': url + '/vulnerabilities/upload/',
	    'Upgrade-Insecure-Requests': '1',
	}

	f = tempfile.NamedTemporaryFile('w+t')
	f.write(get_random_string(100))
	filename = os.path.basename(f.name)
	payload = {
		'MAX_FILE_SIZE': 100000,
		'uploaded': filename,
		'Upload': 'Upload',
		'Content-Type': 'application/octet-stream'
	}
	f = open(f.name, 'rb')
	files = {'file': (filename, f,'text')}
	r = c.post(url + '/vulnerabilities/upload/#', files=files, headers=headers, cookies=cookies, data=payload)
	f.close()
	return r.text, r.status_code, c


def run_xss_s(url, c, cookies, args):
	print('run_xss_s')
	r = c.get(url + '/vulnerabilities/xss_s/', cookies=cookies)
	payload = {
		'txtName': args[0],
		'mtxMessage': args[1],
		'btnSign': 'Sign Guestbook',
		'Content-Type': 'application/x-www-form-urlencoded'
	}
	headers = {
	    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.15; rv:85.0) Gecko/20100101 Firefox/85.0' ,
	    'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
	    'Accept-Language': 'en-US,en;q=0.5',
	    'Content-Type': 'pplication/x-www-form-urlencoded',
	    'Origin': url,
	    'Connection': 'keep-alive',
	    'Referer': url + '/vulnerabilities/xss_s/',
	    'Upgrade-Insecure-Requests': '1',
	}
	r = c.post(url + '/vulnerabilities/xss_s/', headers=headers, cookies=cookies, data=payload)
	return r.text, r.status_code, c


def logout(url, c, cookies):
	r = c.get(url + '/logout.php', cookies=cookies)
	c.close()


def create_request_list(url, username, password):
	requests_to_run = []

	# Instructions
	requests_to_run.append((run_get, ['/instructions.php']))

	# Setup
	requests_to_run.append((run_get, ['/setup.php']))

	# run_brute simulate wrong password
	requests_to_run.append((run_brute, [username, get_random_string(get_random_number(6))]))
	
	# run_brute correct password
	requests_to_run.append((run_brute, [username, password]))
	
	# exec
	requests_to_run.append((run_exec, [random.choice(['localhost', 'google.com', 'google.com'])]))
	
	# change password 
	requests_to_run.append((run_change_password, ['admin', password, get_random_string(4)]))

	# file inclusion
	requests_to_run.append((run_file_inclusion, [random.choice(['file1.txt', 'file2.txt', 'file3.txt'])]))

	# file upload
	requests_to_run.append((run_file_upload, []))

	# run_sqli
	requests_to_run.append((run_get, ['/vulnerabilities/sqli/', 'id='+str(get_random_number(MAX_USERS)), 'Submit=Submit']))
	requests_to_run.append((run_get, ['/vulnerabilities/sqli_blind/', 'id='+str(get_random_number(MAX_USERS)), 'Submit=Submit']))

	#xss
	requests_to_run.append((run_get, ['/vulnerabilities/xss_r/', 'name=' + get_random_string(get_random_number(6))]))	
	requests_to_run.append((run_xss_s, [get_random_string(get_random_number(6)), get_random_string(get_random_number(6))]))

	#security
	requests_to_run.append((run_get, ['/security.php']))

	#php info
	requests_to_run.append((run_get, ['/phpinfo.php']))

	#about
	requests_to_run.append((run_get, ['/about.php']))


	return requests_to_run


def run_generator(url, username, password, level, n, m, max_retries):
	
	# create request list
	requests_to_run = create_request_list(url, username, password)
	requests_count = round(int(n)/int(m))
	chunks =  math.ceil(requests_count/len(requests_to_run))
	if chunks!=0:
		requests_to_run = requests_to_run * chunks


		for i in range(0, n):
			token, c = login(url, username, password)
			cookies = {
			    "Cookie": "security=" + level + "; PHPSESSID=" + token
			}
			requests_to_run = random.sample(requests_to_run, requests_count)
			
			# iterate for each function to run the request
			for (f, p) in requests_to_run:
				retry = 0
				while(retry!=max_retries):
					try:
						_, status_code, c = f(url, c, cookies, p)
						if (status_code!=200):
							print('Error status code ', status_code)
							retry = retry + 1
						else:
							retry = max_retries
					except Exception as ex:
						print('Error while processing request ', ex)
						retry = retry + 1
			
			logout(url, c, cookies)
	print('END')
	

if __name__ == "__main__":
    url = os.getenv('URL', 'http://127.0.0.1:8081')
    username =  os.getenv('USERNAME', 'admin')
    password =  os.getenv('PASSWORD', 'password')
    level = os.getenv('LEVEL', 'low')
    n = int(os.getenv('RUNS', 1000))
    m = int(os.getenv('LOGIN_LOGOUT', 5))
    max_retries = int(os.getenv('MAX_RETRIES', 10))
    run_generator(url, username, password, level, n, m, max_retries)
    











